-- SpamMessageBoard
smb_SpamKeywords = {"LF", "NEED", "WT", "DPS", "TANK", "HEAL", "PST", "ANYONE"}

smb_msgs = {};
smb_sender = {};
smb_time = {};
smb_count = {};
smb_visible = {};
smb_muted = {};
smb_w = 600;  -- Width of window
smb_h = 40;   -- Height of window
smb_s = 40;   -- Total number of entries to allowed display at once

function smb_ReplaceRaidIcons(msg)
    -- Handle raid icons...
    new_msg = msg
    new_msg = string.gsub(new_msg, "{[sS][tT][aA][rR]}",    "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_1:11:11|t")
    new_msg = string.gsub(new_msg, "{[rR][tT]1}",           "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_1:11:11|t")
    
    new_msg = string.gsub(new_msg, "{[cC][iI][rR][cC][lL][eE]}",    "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_2:11:11|t")
    new_msg = string.gsub(new_msg, "{[cC][oO][iI][nN]}",    "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_2:11:11|t")
    new_msg = string.gsub(new_msg, "{[rR][tT]2}",           "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_2:11:11|t")
    
    new_msg = string.gsub(new_msg, "{[dD][iI][aA][mM][oO][nN][dD]}",    "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_3:11:11|t")
    new_msg = string.gsub(new_msg, "{[rR][tT]3}",           "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_3:11:11|t")
    
    new_msg = string.gsub(new_msg, "{[tT][rR][iI][aA][nN][gG][lL][eE]}",    "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_4:11:11|t")
    new_msg = string.gsub(new_msg, "{[rR][tT]4}",           "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_4:11:11|t")
    
    new_msg = string.gsub(new_msg, "{[mM][oO][oO][nN]}",    "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_5:11:11|t")
    new_msg = string.gsub(new_msg, "{[rR][tT]5}",           "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_5:11:11|t")

    new_msg = string.gsub(new_msg, "{[sS][qQ][uU][aA][rR][eE]}", "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_6:11:11|t")
    new_msg = string.gsub(new_msg, "{[rR][tT]6}",           "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_6:11:11|t")
    
    new_msg = string.gsub(new_msg, "{[cC][rR][oO][sS][sS]}", "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_7:11:11|t")
    new_msg = string.gsub(new_msg, "{[xX]}",     "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_7:11:11|t")
    new_msg = string.gsub(new_msg, "{[rR][tT]7}",   "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_7:11:11|t")
    
    new_msg = string.gsub(new_msg, "{[sS][kK][uU][lL][lL]}", "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_8:11:11|t")
    new_msg = string.gsub(new_msg, "{[rR][tT]8}",   "|Tinterface\\TARGETINGFRAME\\UI-RaidTargetingIcon_8:11:11|t")
    return new_msg
end

function smb_out(text)
	DEFAULT_CHAT_FRAME:AddMessage(text);
end

function smb_StartWhisper(this, button)
   local shift_key = IsShiftKeyDown()
   
    
    if button == "RightButton" then
        if shift_key == true then
            local e = DEFAULT_CHAT_FRAME.editBox
            ChatEdit_ActivateChat(e)
            e:SetText("/invite " .. smb_sender[smb_visible[this.id] ]);
            ChatEdit_SendText(e, 0)
        else
            local e = DEFAULT_CHAT_FRAME.editBox
            ChatEdit_ActivateChat(e)
            e:SetText("/who " .. smb_sender[smb_visible[this.id] ]);
            ChatEdit_SendText(e, 0)
        end
        
    elseif button == "LeftButton" then
        if shift_key == true then
            smb_out("|cff00ccffSpam Message Board:|cffffffff Muted " .. smb_sender[smb_visible[this.id]] .. " for this session.")
            table.insert(smb_muted, smb_sender[smb_visible[this.id]])
        elseif smb_visible[this.id] ~= nil then
            local e = DEFAULT_CHAT_FRAME.editBox
            ChatEdit_ActivateChat(e)
            e:SetText("/w " .. smb_sender[smb_visible[this.id]] .. " ");
        end
    end
end

function smb_ShowTooltip(this)
	if smb_visible[this.id] ~= nil then
		local scale,x,y=smb_frame:GetEffectiveScale(),GetCursorPosition();
		local x, y = GetCursorPosition();
		smb_tooltip.text:SetText("|cffffcc00" .. smb_sender[smb_visible[this.id]]  .. " \n|c66666666Left click to whisper  --  Right click to /who\nShift+Left to mute     --  Shift+Right to /invite \n\n |cffffffff" .. smb_msgs[smb_visible[this.id]]);
		smb_tooltip:SetPoint("TOPLEFT", nil, "BOTTOMLEFT", x/scale + 35, y/scale + 5);
		smb_tooltip:SetHeight(smb_tooltip.text:GetHeight() + 32);
		smb_tooltip:Show()
	end
end

function update(t)
	-- First clear all slots...
	for i = 0, smb_s, 1
	do
		smb_frame.text[i]:SetText("")
		smb_frame.time[i]:SetText("")
	end
	
	-- Check if frame is visible or not...
	if smb_frame:IsVisible() then
	else
		smb_msgs = {};
		smb_sender = {};
		smb_time = {};
		smb_count = {};
		smb_visible = {};
		return
	end
	
	
	-- Remove outdated entries for next update...
	local not_done = true;
	
	while not_done do
		not_done = false;
		for i, t in ipairs(smb_time) do
			if (t < GetTime() - 60) then
				table.remove(smb_msgs, i);
				table.remove(smb_sender, i);
				table.remove(smb_time, i);
				table.remove(smb_count, i);
				not_done = true;
				break; -- Break and restart, as indicies have moved...
			end
		end
	end
	
	-- Refill all slots...
	local c = 0;
	smb_visible = {}
	
	
	for i, count in ipairs(smb_count) do

		-- Check for specific keywords to show immediately (instead of waiting on repeat spam)
        for _, words in ipairs(smb_SpamKeywords) do
            if string.match(strupper(smb_msgs[i]), words) then
                count = 3
            end
        end
        
        -- Or...if it matches our filtered text (as a comma-delimited list)...
        local filtered = 0
        local filterBy = strupper(smb_frame.FilterText:GetText())
        if filterBy > "" then
            if filterBy.match(filterBy, ",") then
                for word in string.gmatch(filterBy, '([^,]+)') do
                    if string.match(strupper(smb_msgs[i]), word) then
                        filtered = 1
                    end    
                end
            elseif string.match(strupper(smb_msgs[i]), filterBy) then
                filtered = 1
            end
        end
        
        
        -- Or...if it's to be excluded (as a comma-delimited list)...
        local excludeBy = strupper(smb_frame.ExcludeText:GetText())
        if excludeBy > "" then
            if excludeBy.match(excludeBy, ",") then
                for word in string.gmatch(excludeBy, '([^,]+)') do
                    if string.match(strupper(smb_msgs[i]), word) then
                        filtered = 0
                        count = 0
                    end    
                end
            elseif string.match(strupper(smb_msgs[i]), excludeBy) then
                filtered = 0
                count = 0
            end
        end
        
        -- Make sure not muted...
        for _, muted in ipairs(smb_muted) do
            if string.match(smb_sender[i], muted) then
                count = 0
                filtered = 0
            end
        end
        
		if count > 1 and c < smb_s then
		
			if smb_frame.FilterText:GetText() == "" or filtered == 1 then
				smb_frame.text[c]:SetText("|cffffcc00" .. smb_sender[i] .. ": |cffffffff" .. smb_msgs[i])
				smb_frame.time[c]:SetText("|cff888888" .. math.floor(GetTime() - smb_time[i]) .. "s ago")
				smb_visible[c] = i;
				smb_frame.subframe[c]:EnableMouse(true);
				c = c + 1
			end
		end
	end
	
	for i = c, smb_s, 1 do
		smb_frame.subframe[i]:EnableMouse(false);
	end

	smb_h = c * 18 + 40
	smb_frame:SetHeight(smb_h)
end

function smb_on_chat(self,event,...)
	message,sender, language, channel,aa,ab,ac,ad = ...;
	
	-- Check if message is tracked...
    new_sender = sender
    if string.find(new_sender, "-") then
        new_sender = string.sub(new_sender, 1, string.find(new_sender, "-")-1)
    end
    
    new_msg = message
    if string.find(message, "{") then
        new_msg = smb_ReplaceRaidIcons(new_msg)
    end


	for i, msg in ipairs(smb_msgs) do
		if (msg == new_msg and smb_sender[i] == new_sender) then
			smb_time[i] = GetTime();
			smb_count[i] = smb_count[i]+1;
			-- update(0);
			return
		end
	end
	
	-- Add new message...
	table.insert(smb_msgs, new_msg);
	table.insert(smb_sender, new_sender);
	table.insert(smb_time, GetTime());
	table.insert(smb_count, 1);
	return
end



-- Cmd handler...
function cmd_handler(msg)
    
    if msg == "unmuteall" then
        smb_muted = {};
        smb_out("|cff00ccffSpam Message Board:|cffffffff Unmuated all!");
        return
    elseif msg == "show" then
        -- Reset and show!
        smb_msgs = {};
        smb_sender = {};
        smb_time = {};
        smb_count = {};
        smb_visible = {};
        smb_muted = {};
        
        for i = 0, smb_s, 1 do
            smb_frame.subframe[i]:EnableMouse(false);
            smb_frame.text[i]:SetText("")
            smb_frame.time[i]:SetText("")
        end
        
        smb_frame:Show();
        smb_out("|cff00ccffSpam Message Board reset and enabled!");
    else
        smb_out("|cff00ccffSpam Message Board command list:");
        smb_out("|cffffffff   /smb unmuteall   -  Clears muted list");
        smb_out("|cffffffff   /smb show          -  Reinitializes and displays message board");
    end
end

SLASH_SMB1 = "/smb"
SlashCmdList["SMB"] = cmd_handler;

smb_out("|cff00ccffSpam Message Board Loaded! v2.1.0");
