-- Spam Helper frame and functionality...

function smb_OnEvent(event, arg1)
	if arg1 == "PLAYER_LOGIN" then
		-- Defaults...
		if not smb_g then
			smb_g = {
				text = {
					raid = "",
					suff = "",
					tank = "",
					heal = "",
					dps  = "",
					rule = ""
				},
				num = {
					tank = 2,
					heal = 5,
					dps = 18
				},
				bool = {
					tank = false,
					heal = false,
					dps = false,
					ShowNumbers = false,
					NeedAll = true
				}
			}
			smb_out("Was empty!")
		end
		
		-- Load
		smb_helperFrame.InstanceEditBox:SetText(smb_g.text.raid)
		smb_helperFrame.Rules:SetText(smb_g.text.rule)
		smb_helperFrame.Suffix:SetText(smb_g.text.suff)		

		smb_helperFrame.TankButton:SetChecked(smb_g.bool.tank)
		smb_helperFrame.HealsButton:SetChecked(smb_g.bool.heal)
		smb_helperFrame.DpsButton:SetChecked(smb_g.bool.dps)
		
		smb_helperFrame.TankSpecifyBox:SetText(smb_g.text.tank)
		smb_helperFrame.DpsSpecifyBox:SetText(smb_g.text.dps)
		smb_helperFrame.HealsSpecifyBox:SetText(smb_g.text.heal)
		
		smb_helperFrame.tanks:SetValue(smb_g.num.tank)
		smb_helperFrame.heals:SetValue(smb_g.num.heal)
		smb_helperFrame.dps:SetValue(smb_g.num.dps)
		
		smb_helperFrame.ShowNumbers:SetChecked(smb_g.bool.ShowNumbers)
		smb_helperFrame.NeedAll:SetChecked(smb_g.bool.NeedAll)
		
		
	elseif arg1 == "PLAYER_LOGOUT" then
		smb_g.text.raid = smb_helperFrame.InstanceEditBox:GetText()
		smb_g.text.rule = smb_helperFrame.Rules:GetText()
		smb_g.text.suff = smb_helperFrame.Suffix:GetText()
		
		smb_g.bool.tank = smb_helperFrame.TankButton:GetChecked()
		smb_g.bool.heal = smb_helperFrame.HealsButton:GetChecked()
		smb_g.bool.dps  = smb_helperFrame.DpsButton:GetChecked()
		
		smb_g.text.tank = smb_helperFrame.TankSpecifyBox:GetText()
		smb_g.text.dps  = smb_helperFrame.DpsSpecifyBox:GetText()
		smb_g.text.heal = smb_helperFrame.HealsSpecifyBox:GetText()
		
		
		smb_g.num.tank  = math.floor(smb_helperFrame.tanks:GetValue())
		smb_g.num.heal  = math.floor(smb_helperFrame.heals:GetValue())
		smb_g.num.dps   = math.floor(smb_helperFrame.dps:GetValue())
		
		smb_g.bool.ShowNumbers = smb_helperFrame.ShowNumbers:GetChecked()
		smb_g.bool.NeedAll	   = smb_helperFrame.NeedAll:GetChecked()
	end
end


function smb_helperFrame_ButtonClicked(this)
	local msg = "LFM "
	
	msg = msg .. smb_helperFrame.InstanceEditBox:GetText() .. " - "
	
	-- Just asking for all...
	if smb_helperFrame.NeedAll:GetChecked() then
		msg = msg .. "NEED ALL "
	else
	
		msg = msg .. "NEED "
	
		-- Tank...
		if smb_helperFrame.tanks:GetValue() > 0 then
			if smb_helperFrame.ShowNumbers:GetChecked() then
				msg = msg .. math.floor(smb_helperFrame.tanks:GetValue()) .. "xTanks "
			else
				msg = msg .. "Tanks "
			end
			
			if smb_helperFrame.TankButton:GetChecked() then
				msg = msg .. "(" .. smb_helperFrame.TankSpecifyBox:GetText() .. ") "
			end
		end
		
		-- Heals...
		if smb_helperFrame.heals:GetValue() > 0 then
			if smb_helperFrame.ShowNumbers:GetChecked() then
				msg = msg .. math.floor(smb_helperFrame.heals:GetValue()) .. "xHealers "
			else
				msg = msg .. "Healers "
			end
			
			if smb_helperFrame.HealsButton:GetChecked() then
				msg = msg .. "(" .. smb_helperFrame.HealsSpecifyBox:GetText() .. ") "
			end
		end
		
		-- Dps...
		if smb_helperFrame.dps:GetValue() > 0 then
			if smb_helperFrame.ShowNumbers:GetChecked() then
				msg = msg .. math.floor(smb_helperFrame.dps:GetValue()) .. "xDPS "
			else
				msg = msg .. "DPS "
			end
			
			if smb_helperFrame.DpsButton:GetChecked() then
				msg = msg .. "(" .. smb_helperFrame.DpsSpecifyBox:GetText() .. ") "
			end
		end
	end
	
	if (smb_helperFrame.Rules:GetText() == nil or smb_helperFrame.Rules:GetText() == '') then
	else
		msg = msg .. " - " .. smb_helperFrame.Rules:GetText()
	end
	
	if (smb_helperFrame.Suffix:GetText() == nil or smb_helperFrame.Suffix:GetText() == '') then
	else
		msg = msg .. " - " .. smb_helperFrame.Suffix:GetText()
	end
	
	smb_out(msg)
	
	local e = DEFAULT_CHAT_FRAME.editBox
	ChatEdit_ActivateChat(e)
	e:SetText(e:GetText() .. " " .. msg);
end


local uniquealyzer = 1;
function createCheckbutton(parent, x_loc, y_loc, displayname)
	uniquealyzer = uniquealyzer + 1;
	
	local checkbutton = CreateFrame("CheckButton", "my_addon_checkbutton_0" .. uniquealyzer, parent, "ChatConfigCheckButtonTemplate");
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc);
	getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);
	getglobal(checkbutton:GetName() .. 'Text'):SetTextColor(0.85,0.85,0.85,1.0)

	return checkbutton;
end

function createEditBox(parent, name, x_loc, y_loc, x_size, y_size)
	local editBox = CreateFrame("EditBox", nil, parent, BackdropTemplateMixin and "BackdropTemplate");
	editBox:SetWidth(x_size)
	editBox:SetHeight(y_size)
	editBox:SetAutoFocus(false)
	editBox:SetMultiLine(false)
	editBox:SetFontObject(ChatFontNormal)
	editBox:SetPoint("TOPLEFT",parent,"TOPLEFT",x_loc,y_loc)
	editBox:SetScript("OnEscapePressed", function(this) this:ClearFocus() end)
	editBox:SetScript("OnEscapePressed", function(this) this:ClearFocus() end)

	local backDrop = CreateFrame("Frame", nil, parent, BackdropTemplateMixin and "BackdropTemplate");
	backDrop:SetWidth(x_size)
	backDrop:SetHeight(y_size)
	backDrop:SetPoint("TOPLEFT",parent,"TOPLEFT",x_loc,y_loc)
	backDrop:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background" });
	backDrop:SetBackdropColor(0,0,0,1);
	return editBox
end


--simple round number func
local SimpleRound = function(val,valStep)
	return floor(val/valStep)*valStep
end
 
  --basic slider func
local CreateBasicSlider = function(parent, name, title, x_loc, y_loc, minVal, maxVal, valStep)
	local slider = CreateFrame("Slider", name, parent, "OptionsSliderTemplate")
	local editbox = CreateFrame("EditBox", "$parentEditBox", slider, "InputBoxTemplate")
	slider:SetMinMaxValues(minVal, maxVal)
	--slider:SetValue(0)
	slider:SetPoint("TOPLEFT",parent,"TOPLEFT",x_loc,y_loc)
	slider:SetValueStep(valStep)
	slider.text = _G[name.."Text"]
	slider.text:SetText(title)
	slider.text:SetTextColor(0.85,0.64,0.125,1.0)
	slider.textLow = _G[name.."Low"]
	slider.textHigh = _G[name.."High"]
	slider.textLow:SetText(floor(minVal))
	slider.textHigh:SetText(floor(maxVal))
	slider.textLow:SetTextColor(0.4,0.4,0.4)
	slider.textHigh:SetTextColor(0.4,0.4,0.4)
	editbox:SetSize(50,30)
	editbox:ClearAllPoints()
	editbox:SetPoint("LEFT", slider, "RIGHT", 15, 0)
	editbox:SetText(slider:GetValue())
	editbox:SetAutoFocus(false)
	slider:SetScript("OnValueChanged", function(self,value)
		self.editbox:SetText(SimpleRound (value,valStep))
	end)
	editbox:SetScript("OnTextChanged", function(self)
		local val = self:GetText()
		if tonumber(val) then
			self:GetParent():SetValue(val)
		end
	end)
	editbox:SetScript("OnEnterPressed", function(self)
		local val = self:GetText()
		if tonumber(val) then
			self:GetParent():SetValue(val)
			self:ClearFocus()
		end
	end)
	slider.editbox = editbox
	return slider
  end

function smb_openHelper(this)
	if smb_helperFrame.Hidden then
		smb_helperFrame:Show();
		smb_helperFrame.Hidden = false
	else
		smb_helperFrame:Hide();
		smb_helperFrame.Hidden = true
	end
end

-- Basic Frame creation
smb_helperFrame = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate");
smb_helperFrame:ClearAllPoints()
smb_helperFrame:SetPoint("TOPLEFT",UIParent)
smb_helperFrame:SetHeight(450)
smb_helperFrame:SetWidth(275)

smb_helperFrame:RegisterEvent("PLAYER_LOGIN"); -- Fired when saved variables are loaded
smb_helperFrame:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out
smb_helperFrame:SetScript("OnEvent", smb_OnEvent);

smb_helperFrame:SetBackdrop({
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
	edgeFile = "Interface\\AddOns\\SpamMessageBoard\\textures\\otravi-semi-full-border", edgeSize = 32,
	insets = {left = 1, right = 1, top = 32, bottom = 1},
})
smb_helperFrame:SetBackdropBorderColor(0.0,0.0,1.0)
smb_helperFrame:SetBackdropColor(24/255, 24/255, 24/255)

smb_helperFrame:SetScale(1)
smb_helperFrame:EnableMouse(true)
smb_helperFrame:SetMovable(true)
smb_helperFrame:RegisterForDrag("LeftButton")
smb_helperFrame:SetScript("OnDragStart",smb_helperFrame.StartMoving)
smb_helperFrame:SetScript("OnDragStop",smb_helperFrame.StopMovingOrSizing)

smb_helperFrame:SetScript("OnMouseDown", function(this) 
					if ( ( ( not this.isLocked ) or ( this.isLocked == 0 ) ) and ( arg1 == "LeftButton" ) ) then
					  this:StartMoving();
					  this.isMoving = true;
					 end
					end)
smb_helperFrame:SetScript("OnMouseUp", function(this) 
					if ( this.isMoving ) then
					  this:StopMovingOrSizing();
					  this.isMoving = false;
					  if this.SavePosition then
						this:SavePosition()
					  end
					 end
					end)
					
-- Close Button
smb_helperFrame.CloseButton=CreateFrame("Button",nil,smb_helperFrame, BackdropTemplateMixin and "BackdropTemplate")
smb_helperFrame.CloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
smb_helperFrame.CloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
smb_helperFrame.CloseButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
smb_helperFrame.CloseButton:SetWidth(20)
smb_helperFrame.CloseButton:SetHeight(20)
smb_helperFrame.CloseButton:SetPoint("TOPRIGHT",smb_helperFrame,"TOPRIGHT",-4,-12)
smb_helperFrame.CloseButton:SetScript("OnClick", smb_openHelper)



-- TITLE
smb_helperFrame.Title=smb_helperFrame:CreateFontString(nil,"ARTWORK","GameFontNormal")
smb_helperFrame.Title:SetPoint("TOPLEFT",smb_helperFrame,"TOPLEFT",6,-15)
smb_helperFrame.Title:SetTextColor(1.0,1.0,1.0,1.0)
smb_helperFrame.Title:SetText("Spam Helper:")



-- RAID edit box...
smb_helperFrame.InstanceEditBox = createEditBox(smb_helperFrame, "txtRaid", 50, -40, 215, 18)
smb_helperFrame.Instance = smb_helperFrame:CreateFontString(nil,"ARTWORK","GameFontNormal")
smb_helperFrame.Instance:SetPoint("TOPLEFT",smb_helperFrame,"TOPLEFT",10,-43)
smb_helperFrame.Instance:SetTextColor(0.85,0.64,0.125,1.0)
smb_helperFrame.Instance:SetText("Raid:")

 
 
-- TANKS ---
smb_helperFrame.tanks = CreateBasicSlider(smb_helperFrame, "numTanks", "Tanks", 10, -80, 0, 5, 1)
smb_helperFrame.TankSpecifyBox = createEditBox(smb_helperFrame, "txtTank", 110, -110, 155, 18)
smb_helperFrame.TankButton = createCheckbutton(smb_helperFrame, 30, -108, "Specify: ");
smb_helperFrame.TankButton.tooltip = "Request specific type of tank in spam message.";




-- HEALERS ---
smb_helperFrame.heals = CreateBasicSlider(smb_helperFrame, "numHealers", "Healers", 10, -155, 0, 10, 1)
smb_helperFrame.HealsSpecifyBox = createEditBox(smb_helperFrame, "txtHeals", 110, -185, 155, 18)
smb_helperFrame.HealsButton = createCheckbutton(smb_helperFrame, 30, -183, "Specify: ");
smb_helperFrame.HealsButton.tooltip = "Request specific type of healer in spam message.";




-- DPS
smb_helperFrame.dps = CreateBasicSlider(smb_helperFrame, "numDps", "Damage", 10, -230, 0, 30, 1)
smb_helperFrame.DpsSpecifyBox = createEditBox(smb_helperFrame, "txtDps", 110, -260, 155, 18)
smb_helperFrame.DpsButton = createCheckbutton(smb_helperFrame, 30, -258, "Specify: ");
smb_helperFrame.DpsButton.tooltip = "Request specificw type of DPS in spam message.";



-- Rules Text...
smb_helperFrame.OtherLabel = smb_helperFrame:CreateFontString(nil,"ARTWORK","GameFontNormal")
smb_helperFrame.OtherLabel:SetPoint("TOPLEFT",smb_helperFrame,"TOPLEFT",10,-292)
smb_helperFrame.OtherLabel:SetTextColor(0.85,0.64,0.125,1.0)
smb_helperFrame.Rules = createEditBox(smb_helperFrame, "txtR", 55, -290, 210, 18)
smb_helperFrame.OtherLabel:SetText("Rules:")

-- Suffix Text...
smb_helperFrame.OtherLabel = smb_helperFrame:CreateFontString(nil,"ARTWORK","GameFontNormal")
smb_helperFrame.OtherLabel:SetPoint("TOPLEFT",smb_helperFrame,"TOPLEFT",10,-312)
smb_helperFrame.OtherLabel:SetTextColor(0.85,0.64,0.125,1.0)
smb_helperFrame.OtherLabel:SetText("Suffix:")
smb_helperFrame.Suffix = createEditBox(smb_helperFrame, "txtOther", 55, -310, 210, 18)


-- Options
smb_helperFrame.OptionLabel = smb_helperFrame:CreateFontString(nil,"ARTWORK","GameFontNormal")
smb_helperFrame.OptionLabel:SetPoint("TOPLEFT",smb_helperFrame,"TOPLEFT",10,-330)
smb_helperFrame.OptionLabel:SetTextColor(0.85,0.64,0.125,1.0)
smb_helperFrame.OptionLabel:SetText("Options:")

smb_helperFrame.ShowNumbers = createCheckbutton(smb_helperFrame, 20, -350, "Include numbers");
smb_helperFrame.ShowNumbers.tooltip = "If checked, will include numbers of needed roles in message.";

smb_helperFrame.NeedAll = createCheckbutton(smb_helperFrame, 20, -370, "Just say need 'All'");
smb_helperFrame.NeedAll.tooltip = "If checked, will say need all instead of individual roles.";


-- Spam! button...
smb_helperFrame.SpamButton = CreateFrame("Button", nil, smb_helperFrame, BackdropTemplateMixin and "BackdropTemplate")
smb_helperFrame.SpamButton:SetPoint("TOPLEFT", smb_helperFrame, "TOPLEFT", 60, -405)
smb_helperFrame.SpamButton:SetWidth(155)
smb_helperFrame.SpamButton:SetHeight(35)

smb_helperFrame.SpamButton:SetText("Spam!")
smb_helperFrame.SpamButton:SetNormalFontObject("GameFontNormal")

local ntex = smb_helperFrame.SpamButton:CreateTexture()
ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
ntex:SetTexCoord(0, 0.625, 0, 0.6875)
ntex:SetAllPoints()	
smb_helperFrame.SpamButton:SetNormalTexture(ntex)

local htex = smb_helperFrame.SpamButton:CreateTexture()
htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
htex:SetTexCoord(0, 0.625, 0, 0.6875)
htex:SetAllPoints()
smb_helperFrame.SpamButton:SetHighlightTexture(htex)

local ptex = smb_helperFrame.SpamButton:CreateTexture()
ptex:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
ptex:SetTexCoord(0, 0.625, 0, 0.6875)
ptex:SetAllPoints()
smb_helperFrame.SpamButton:SetPushedTexture(ptex)

smb_helperFrame.SpamButton:SetScript("OnClick", smb_helperFrame_ButtonClicked)




-- Hide by default...
smb_helperFrame.Hidden = true
smb_helperFrame:Hide()